package kiev.stdlib;

public class ArrayEnumerator<A> implements Enumeration<A>, Cloneable {

	private A[]		arr;
	private int		top;
	
	public ArrayEnumerator(A[] arr) {
		this.arr = arr;
	}
	
	public boolean	hasMoreElements() {
		return top < arr.length;
	}
	public A		nextElement() {
		return arr[top++];
	}
	
	public static boolean contains(Object[] ar, Object val) {
		for(int i=0; i < ar.length; i++) {
			if( val!=null && (val == ar[i] || val.equals(ar[i])) )
				return true;
		}
		return false;
	}

	public static boolean contains(int[] ar, int val) {
		for(int i=0; i < ar.length; i++)
			if( val == ar[i] )
				return true;
		return false;
	}

	public static boolean contains(long[] ar, long val) {
		for(int i=0; i < ar.length; i++)
			if( val == ar[i] )
				return true;
		return false;
	}

	public static boolean contains(float[] ar, float val) {
		for(int i=0; i < ar.length; i++)
			if( val == ar[i] )
				return true;
		return false;
	}

	public static boolean contains(double[] ar, double val) {
		for(int i=0; i < ar.length; i++)
			if( val == ar[i] )
				return true;
		return false;
	}

	public static boolean contains(boolean[] ar, boolean val) {
		for(int i=0; i < ar.length; i++)
			if( val == ar[i] )
				return true;
		return false;
	}

	public static boolean contains(byte[] ar, byte val) {
		for(int i=0; i < ar.length; i++)
			if( val == ar[i] )
				return true;
		return false;
	}

	public static boolean contains(char[] ar, char val) {
		for(int i=0; i < ar.length; i++)
			if( val == ar[i] )
				return true;
		return false;
	}

	public static boolean contains(short[] ar, short val) {
		for(int i=0; i < ar.length; i++)
			if( val == ar[i] )
				return true;
		return false;
	}

}

