class Test20 {
	public static class StaticSubTest20 {
		int i;
		Test20 tst;
		StaticSubTest20(Test20 tst) {	
			this.tst = tst;
		}
		public String toString() {
			return "static sub of "+tst+" = "+getClass();
		}
	}
	public class DynamicSubTest20 {
		int i;
		DynamicSubTest20() {	
		}
		public String toString() {
			return "dynamic sub of "+Test20.this+" = "+getClass();
		}
	}
	public static void main(String[] args) {
		Test20 tst = new Test20();
		tst.test();
	}
	public void test() {
		StaticSubTest20 st = new StaticSubTest20(new Test20());
		System.out.println(st);
		DynamicSubTest20 dt1 = new DynamicSubTest20();
		System.out.println(dt1);
		DynamicSubTest20 dt2 = this.new DynamicSubTest20();
		System.out.println(dt2);
		final int i = 100;
		int j = 200;
		class InnerSubTest20 {
			InnerSubTest20() {	
			}
			public String toString() {
                                return "inner dynamic sub of "+Test20.this+" = "+getClass()+"\n\r\ti = "+i++;
			}
		};
		InnerSubTest20 it = new InnerSubTest20();
		System.out.println(it);
		System.out.println("now i = "+i);
		Object at = new Object() {
			public String toString() {
				return "anonymouse inner dynamic sub of "+Test20.this+" = "+getClass()+"\n\r\tj = "+j;
			}
		};
		i = 150;
		j = 250;
		System.out.println(at);
	}

	public String toString() {
		return getClass().toString();
	}
}