class Test30_A {

	multimethod void mm1(Test30_A o) {
		System.out.println("A.mm1 - A:  \t"+o.getClass());
	}

	multimethod void mm2(Test30_A o1, Test30_A o2) {
		System.out.println("A.mm1 - A/A:  \t"+o1.getClass()+"/"+o2.getClass());
	}

}

class Test30_B extends Test30_A {

	multimethod void mm1(Test30_B o) {
		System.out.println("B.mm1 - B:  \t"+o.getClass());
	}

	multimethod void mm2(Test30_A o1, Test30_A o2) {
		System.out.println("B.mm1 - A/A:  \t"+o1.getClass()+"/"+o2.getClass());
	}

	multimethod void mm2(Test30_B o1, Test30_B o2) {
		System.out.println("B.mm1 - B/B:  \t"+o1.getClass()+"/"+o2.getClass());
	}

}

class Test30_C extends Test30_B {

	multimethod void mm1(Test30_C o) {
		System.out.println("C.mm1 - C: \t"+o.getClass());
	}

	multimethod void mm1(Test30_B o) {
		System.out.println("C.mm1 - B:   \t"+o.getClass());
	}

	multimethod void mm2(Test30_C o1, Test30_C o2) {
		System.out.println("C.mm1 - C/C:  \t"+o1.getClass()+"/"+o2.getClass());
	}

	multimethod void mm2(Test30_A o1, Test30_C o2) {
		System.out.println("C.mm1 - A/C:  \t"+o1.getClass()+"/"+o2.getClass());
	}

	multimethod void mm2(Test30_C o1, Test30_A o2) {
		System.out.println("C.mm1 - C/A:  \t"+o1.getClass()+"/"+o2.getClass());
	}

	multimethod void mm2(Test30_B o1, Test30_B o2) {
		System.out.println("C.mm1 - B/B:  \t"+o1.getClass()+"/"+o2.getClass());
	}

}

class Test30_D extends Test30_C {

	multimethod void mm1(Test30_A o) {
		System.out.println("D.mm1 - A:  \t"+o.getClass());
	}

}

class Test30 {

	public static void main(String[] args) {
		Test30_A a = new Test30_A();
		Test30_B b = new Test30_B();
		Test30_C c = new Test30_C();
		Test30_D d = new Test30_D();
		
		Test30_A t;
		
		t = a;
		System.out.println("A:");
		t.mm1(a);
		t.mm1(b);
		t.mm1(c);
		t.mm1(d);
		
		t = b;
		System.out.println("B:");
		t.mm1(a);
		t.mm1(b);
		t.mm1(c);
		t.mm1(d);
		
		t = c;
		System.out.println("C:");
		t.mm1(a);
		t.mm1(b);
		t.mm1(c);
		t.mm1(d);
		
		t = d;
		System.out.println("D:");
		t.mm1(a);
		t.mm1(b);
		t.mm1(c);
		t.mm1(d);
		
		
		t = a;
		System.out.println("A:");
		t.mm2(a,a);
		t.mm2(b,b);
		t.mm2(c,c);
		t.mm2(d,d);
		
		t = b;
		System.out.println("B:");
		t.mm2(a,a);
		t.mm2(a,b);
		t.mm2(b,a);
		t.mm2(b,b);
		
		t = c;
		System.out.println("C:");
		t.mm2(a,a);
		t.mm2(a,b);
		t.mm2(b,a);
		t.mm2(b,b);
		t.mm2(c,a);
		t.mm2(c,b);
		t.mm2(a,c);
		t.mm2(b,c);
		t.mm2(c,c);
		
		
	}
}

