public class Test52 extends Test50 {

	public static void main(String[] args) {
		if( args.length >= 1 && args[0].equals("-debug") ) {
			PEnv.debug = true;
			String[] ar = new String[args.length-1];
			for(int i=1; i < args.length; i++)
				ar[i-1] = args[i];
			args = ar;
		}
		String val1=null, val2=null, val3=null;
		if(args.length >= 1 && !args[0].equals("_")) val1 = args[0];
		if(args.length >= 2 && !args[1].equals("_")) val2 = args[1];
		if(args.length >= 3 && !args[2].equals("_")) val3 = args[2];
	
		Test52 t = new Test52();

		PVar<String> x = new PVar<String>();
		PVar<String> y = new PVar<String>();
		
		x.$var = val1;
		System.out.println("t.test1(X) = "+t.test1(x)+"; x = "+x.$var);
		
		x.$var = val1;
		foreach( t.test2(x) ) { System.out.println("t.test2(X) = true; x = "+x.$var); }
		
		x.$var = val1;
		foreach( t.test3(x) ) { System.out.println("t.test3(X) = true; x = "+x.$var); }
		
		x.$var = val1;
		foreach( t.test4(x) ) { System.out.println("t.test4(X) = true; x = "+x.$var); }
		
		x.$var = val1;
		foreach( t.test5(x) ) { System.out.println("t.test5(X) = true; x = "+x.$var); }
		
		x.$var = val1;
		foreach( t.test6(x) ) { System.out.println("t.test6(X) = true; x = "+x.$var); }
		
		x.$var = val1;
		foreach( t.test7(x) ) { System.out.println("t.test7(X) = true; x = "+x.$var); }
		
		x.$var = val1;
		y.$var = val2;
		foreach( t.test8(x,y) ) { System.out.println("t.test8(X,Y) = true; x = "+x.$var+"; y = "+y.$var); }

		PVar<Integer> a = new PVar<Integer>();
		PVar<Integer> b = new PVar<Integer>();
		
		try {
			if( val1 != null ) a.$var = Integer.valueOf(val1);
			if( val2 != null ) b.$var = Integer.valueOf(val2);
		} catch(NumberFormatException e) {}
		foreach( t.test9(a,b) ) { System.out.println("t.test9(A,B) = true; a = "+a.$var+"; b = "+b.$var); }

		PVar<Integer> a = new PVar<Integer>();
		foreach( t.test10(a) ) { System.out.println("t.test10(A) = true; a = "+a.$var); }

		a.$var = null;
		foreach( t.test11(a) ) { System.out.println("t.test11(A) = true; a = "+a.$var); }

	}

	rule test7(pvar String X) {
		test2(X), { X ?= "two";  test6(X) }
	}
	
	Integer[] iarr = new Integer[]{ new Integer(0), new Integer(1), new Integer(2) };
	
	rule test10(pvar Object X) {
		X @= iarr, ((Number)X.$var).intValue() > 1
	}

	Integer[] iarr2 = new Integer[0];
	
	rule test11(pvar Object X) {
		X @= iarr2, ((Number)X.$var).intValue() > 1
	}

}
