package kiev.stdlib;

public class AssertionFailedException extends RuntimeException {

	public AssertionFailedException() { super(); }

	public AssertionFailedException(String msg) { super(msg); }

}

public class Debug {

	public static void trace(boolean cond, String msg) {
		if( cond ) System.out.println(msg);
	}

	public static void assert(boolean cond) {
		if( !cond ) throw new AssertionFailedException();
	}

	public static void assert(boolean cond, String msg) {
		if( !cond ) throw new AssertionFailedException(msg);
	}

}

