package kiev.stdlib;

public class MessageNotUnderstoodException extends RuntimeException {
	public int		arity;
	public int		hash;
	public String	name;
	public MessageNotUnderstoodException() { super(); }
	public MessageNotUnderstoodException(String msg) { super(msg); }
	public MessageNotUnderstoodException(int arity,int hash) {
		super(hash+"/"+arity);
	}
	public MessageNotUnderstoodException(int arity, int hash, String name) {
		super(name+"/"+arity);
	}
}

