public class Test50 {

	public static void main(String[] args) {
		if( args.length >= 1 && args[0].equals("-debug") ) {
			PEnv.debug = true;
			String[] ar = new String[args.length-1];
			for(int i=1; i < args.length; i++)
				ar[i-1] = args[i];
			args = ar;
		}
		String val1=null, val2=null, val3=null;
		if(args.length >= 1 && !args[0].equals("_")) val1 = args[0];
		if(args.length >= 2 && !args[1].equals("_")) val2 = args[1];
		if(args.length >= 3 && !args[2].equals("_")) val3 = args[2];
	
		Test50 t = new Test50();

		PVar<String> x = new PVar<String>();
		PVar<String> y = new PVar<String>();
		
		x.$var = val1;
		System.out.println("t.test1(X) = "+t.test1(x)+"; x = "+x.$var);
		
		x.$var = val1;
		foreach( t.test2(x) ) { System.out.println("t.test2(X) = true; x = "+x.$var); }
		
		x.$var = val1;
		foreach( t.test3(x) ) { System.out.println("t.test3(X) = true; x = "+x.$var); }
		
		x.$var = val1;
		foreach( t.test4(x) ) { System.out.println("t.test4(X) = true; x = "+x.$var); }
		
		x.$var = val1;
		foreach( t.test5(x) ) { System.out.println("t.test5(X) = true; x = "+x.$var); }
		
		x.$var = val1;
		foreach( t.test6(x) ) { System.out.println("t.test6(X) = true; x = "+x.$var); }
		
		x.$var = val1;
		foreach( t.test7(x) ) { System.out.println("t.test7(X) = true; x = "+x.$var); }
		
		x.$var = val1; y.$var = val2;
		foreach( t.test8(x,y) ) { System.out.println("t.test8(X,Y) = true; x = "+x.$var+"; y = "+y.$var); }

		PVar<Integer> a = new PVar<Integer>();
		PVar<Integer> b = new PVar<Integer>();
		
		try {
			if( val1 != null ) a.$var = Integer.valueOf(val1);
			if( val2 != null ) b.$var = Integer.valueOf(val2);
		} catch(NumberFormatException e) {}
		foreach( t.test9(a,b) ) { System.out.println("t.test9(A,B) = true; a = "+a.$var+"; b = "+b.$var); }
	}

	rule test1(pvar String X) {
		X ?= "one"
	}

//	static String[] test2_X = {"one","two","three"};
//	static List<String> test2_X =
//		new List.Cons<String>("one",new List.Cons<String>("two",new List.Cons<String>("three",List.Nil)));
	static Hash<String> test2_X;
	static {
		test2_X = new Hash<String>();
		test2_X.put("one");
		test2_X.put("two");
		test2_X.put("three");
	}
	rule test2(pvar String X) {
		X @= test2_X.elements()
	}

	rule test3(pvar String X) {
		X ?= "one"
	;	X @= test2_X
	}

	rule test4(pvar String X) {
		X @= test2_X, X ?= "two"
	}

	rule test5(pvar String X) {
		X ?= "one"
	;	X ?= "two"
	;	X @= test2_X, X ?= "three"
	;	X ?= "four" , X @= test2_X
	}

	rule test6(pvar String X) {
		X @= test2_X,
		{
			X ?= "two"
		;	X @= test2_X, X ?= "three",
			{
				X ?= "one"
			;	X ?= "three"
			}
		;
			X ?= "four"
		}
	}

	rule test7(pvar String X) {
		test2(X), { X ?= "two" ; test6(X) }
	}

	int toInt(String str) {
		if( str == null ) return 0;
		if( str.equals("one") ) return 1;
		if( str.equals("two") ) return 2;
		if( str.equals("three") ) return 3;
		return 0;
	}
	
	boolean sgreater(pvar String X, pvar String Y) {
		return
			toInt(X.$var) > 
				toInt(Y.$var);
	}

	boolean igreater(pvar Integer X, pvar Integer Y) {
		return X.$var.intValue() == (Y.$var.intValue() + 1);
	}
	
	rule test8(pvar String X, pvar String Y)
		pvar String Z;
	{
		X @= test2_X, Y @= test2_X,
		{
			sgreater(X,Y)
		;
			Z @= test2_X,
			sgreater(X,Z),
			test8(Z,Y)
		}
	}

	static Integer[] test9_X =
		{ new Integer(0), new Integer(1), new Integer(2), new Integer(3), new Integer(4), new Integer(5) };

	rule test9(pvar Integer X, pvar Integer Y)
		pvar Integer Z;
	{
		X @= test9_X, Y @= test9_X,
		{
			igreater(X,Y)
		;
			Z @= test9_X, igreater(X,Z), test9(Z,Y)
		}
	}

}
