public class Test53 {

	static List<Integer> list1 =
		new List.Cons<Integer>(new Integer(0)
			,new List.Cons<Integer>(new Integer(3),
				new List.Cons<Integer>(new Integer(5)
					,List.Nil)));

	static List<Integer> list2 =
		new List.Cons<Integer>(new Integer(1)
			,new List.Cons<Integer>(new Integer(2),
				new List.Cons<Integer>(new Integer(5)
					,List.Nil)));

	public static void main(String[] args) {
		if( args.length >= 1 && args[0].equals("-debug") ) {
			PEnv.debug = true;
			String[] ar = new String[args.length-1];
			for(int i=1; i < args.length; i++)
				ar[i-1] = args[i];
			args = ar;
		}
	
		Test53 t = new Test53();

		PVar<List<Integer>> x = new PVar<List<Integer>>(list1);
		PVar<List<Integer>> y = new PVar<List<Integer>>(list2);
		PVar<List<Integer>> z = new PVar<List<Integer>>(List.Nil);
		PVar<Integer> max = new PVar<Integer>(new Integer(-1000));
		
		System.out.println("Sorted merging of\n"+list1+"\nand\n"+list2);
		t.merge(x,y,z);
		System.out.println("Result list is\n"+z.$var+"\n");

		System.out.println("Selecting greatest in\n"+z.$var);
		t.max(z,max);
		System.out.println("Result list is\n"+max.$var+"\n");
	}
	
	boolean debug(pvar List<Integer> lst1, pvar List<Integer> lst2, pvar List<Integer> res) {
		if(PEnv.debug)
			System.out.println("Current lists are:\n1: "+lst1.$var+"\n2: "+lst2.$var+"\nR: "+res.$var+"\n");
		return true;
	}
	
	rule merge(pvar List<Integer> lst1, pvar List<Integer> lst2, pvar List<Integer> res)
	{
		lst1 ?= List.Nil, lst2 ?= List.Nil, true
	;
		lst1 ?= List.Nil,
		res.$var = res.concat(lst2.head()),
		debug(lst1,lst2,res),
		merge(lst1,lst2.tail(),res)
	;
		lst2 ?= List.Nil,
		res.$var = res.concat(lst1.head()),
		debug(lst1,lst2,res),
		merge(lst1.tail(),lst2,res)
	;
		lst1.head().intValue() > lst2.head().intValue(),
		res.$var = res.concat(lst2.head()),
		debug(lst1,lst2,res),
		merge(lst1,lst2.tail(),res)
	;
		lst1.head().intValue() < lst2.head().intValue(),
		res.$var = res.concat(lst1.head()),
		debug(lst1,lst2,res),
		merge(lst1.tail(),lst2,res)
	;
		lst1.head().intValue() == lst2.head().intValue(),
		res.$var = res.concat(lst1.head()),
		debug(lst1,lst2,res),
		merge(lst1.tail(),lst2.tail(),res)
	}
	
	rule max(pvar List<Integer> lst, pvar Integer res)
	{
		lst ?= List.Nil
	;
		{	res.intValue() < lst.head().intValue(), res.$var = lst.head()
		;	true
		},
		max(lst.tail(), res)
	}

}
