public class Test57 {

	static class Test<A> {
		String toString() {
			return $typeinfo.toString();
		}
	}
	
	public static void main(String[] args) {
		if( args.length >= 1 && args[0].equals("-debug") ) {
			PEnv.debug = true;
			String[] ar = new String[args.length-1];
			for(int i=1; i < args.length; i++)
				ar[i-1] = args[i];
			args = ar;
		}

		Test57 t = new Test57();
		
		PVar<Object>	o;
		
		PVar<Integer> i = new PVar<Integer>(new Integer(1));
		System.out.println("Call to t.test("+i+");");
		o = i;
		System.out.println("Call to t.test("+o+"); / "+o.self.getClass());
		t.test(o);

		t.test();
	}
	
	rule test()
		pvar Object o;
		pvar Integer i;
		pvar String s;
		pvar Test<Integer> ti;
		pvar Test<String> ts;
	{
		i ?= new Integer(1),
		o = i,
		test(o),
		s ?= "string",
		o = s,
		test(o),
		ti ?= new Test<Integer>(),
		o = ti,
		test(o),
		ts ?= new Test<String>(),
		o = ts,
		test(o)
	}
	
	rule multimethod test(pvar Object o) {
		System.out.println("test(Object) is called: "+o)
	}

	rule multimethod test(pvar Integer i) {
		System.out.println("test(Integer) is called: "+i)
	}

	rule multimethod test(pvar String s) {
		System.out.println("test(String) is called: "+s)
	}

	rule multimethod test(pvar Test<Integer> ti) {
		System.out.println("test(Test<Integer>) is called: "+ti)
	}

	rule multimethod test(pvar Test<String> ts) {
		System.out.println("test(Test<String>) is called: "+ts)
	}
	
}

