public class Test59 {

	public static ()->rule	r1 = fun ()->rule { true };
	public static (String)->rule	r2 = fun (String s)->rule { s == "true" };
	public static (PVar<String>)->rule	r3 = fun (pvar String s)->rule { s ?= "true" ; s ?= "TRUE" };
	
	rule static r4(pvar String s) { s ?= "true" ; s ?= "TRUE" }
	
	public static void main(String[] args) {
		if( args.length >= 1 && args[0].equals("-debug") ) {
			PEnv.debug = true;
			String[] ar = new String[args.length-1];
			for(int i=1; i < args.length; i++)
				ar[i-1] = args[i];
			args = ar;
		}
	
		System.out.println("Static...");

		System.out.println("()->rule r1 is "+r1());
		System.out.println("(\"true\")->rule r2 is "+r2("true"));
		System.out.println("(\"false\")->rule r2 is "+r2("false"));
		PVar<String> s = new PVar<String>("true");
		System.out.println("(\"true\")->rule r3 is "+r3(s));
		s.$var = null;
		foreach( r3(s) )
			System.out.println("(s)->rule r3 : s = "+s);
		s.$var = null;
		(PVar<String>)->rule f4 = r4;
		foreach( f4(s) )
			System.out.println("(s)->rule f4: s = "+s);
		new Test59().test();
	}
	
	rule rd4(pvar String s) { s ?= "true" ; s ?= "TRUE" }
	
	void test() {
		()->rule	rd1 = fun ()->rule { true };
		(String)->rule	rd2 = fun (String s)->rule { s == "true" };
		(PVar<String>)->rule	rd3 = fun (pvar String s)->rule { s ?= "true" ; s ?= "TRUE" };
	
		System.out.println("\nVirtuals...");

		System.out.println("()->rule rd1 is "+rd1());
		System.out.println("(\"true\")->rule rd2 is "+rd2("true"));
		System.out.println("(\"false\")->rule rd2 is "+rd2("false"));
		PVar<String> s = new PVar<String>("true");
		System.out.println("(\"true\")->rule rd3 is "+rd3(s));
		s.$var = null;
		foreach( rd3(s) )
			System.out.println("(s)->rule rd3 : s = "+s);
		s.$var = null;
		(PVar<String>)->rule fd4 = rd4;
		foreach( fd4(s) )
			System.out.println("(s)->rule fd4: s = "+s);
		()->rule tr = True;
		System.out.println("not(()->rule) = "+not(tr));
		(String,Boolean)->rule eq = Eq;
		System.out.println("notEquals((\"true\","+Boolean.TRUE+")->rule, TRUE, TRUE) = "+notEquals(eq,"true",Boolean.TRUE));
	}

	rule True() { true }
	
	rule not(pvar ()->rule r) {
		r.$var(), $cut, false;
		true
	}
	
	rule Eq(String o1, Boolean o2) { o1==null && o2==null ; o1 != null, o1.equals(o2.toString()) }

	rule notEquals(pvar (String,Boolean)->rule eq, String o1, Boolean o2) {
		eq.$var(o1,o2), $cut, false;
		true
	}

}

